<?php
/**
*
* @package - Affiliates on index
* @version $Id: affiliates_index_install.php 45 2010-28-09 07:23:19Z jakk $
* @copyright (c) jakk ( www.ivemfinity.com/ )
* @license http://opensource.org/licenses/gpl-license.php GNU Public License 
*
*/

/**
* @ignore
*/
define('UMIL_AUTO', true);
define('IN_PHPBB', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);
$user->session_begin();
$auth->acl($user->data);
$user->setup();

if (!file_exists($phpbb_root_path . 'umil/umil_auto.' . $phpEx))
{
	trigger_error('Please download the latest UMIL (Unified MOD Install Library) from: <a href="http://www.phpbb.com/mods/umil/">phpBB.com/mods/umil</a>', E_USER_ERROR);
}

// The name of the mod to be displayed during installation.
$mod_name = 'AFFILIATES_ON_INDEX';

/*
* The name of the config variable which will hold the currently installed version
* You do not need to set this yourself, UMIL will handle setting and updating the version itself.
*/
$version_config_name = 'affiliates_index_version';

/*
* The language file which will be included when installing
* Language entries that should exist in the language file for UMIL (replace $mod_name with the mod's name you set to $mod_name above)
* $mod_name
* 'INSTALL_' . $mod_name
* 'INSTALL_' . $mod_name . '_CONFIRM'
* 'UPDATE_' . $mod_name
* 'UPDATE_' . $mod_name . '_CONFIRM'
* 'UNINSTALL_' . $mod_name
* 'UNINSTALL_' . $mod_name . '_CONFIRM'
*/
$language_file = 'mods/affiliates_index';

/*
* The array of versions and actions within each.
* You do not need to order it a specific way (it will be sorted automatically), however, you must enter every version, even if no actions are done for it.
*
* You must use correct version numbering.  Unless you know exactly what you can use, only use X.X.X (replacing X with an integer).
* The version numbering must otherwise be compatible with the version_compare function - http://php.net/manual/en/function.version-compare.php
*/
$versions = array(
	// Version 0.0.1
	'0.0.1' => array(
		// Now to add some permission settings
		'permission_add' => array(
			array('a_affiliates_index_manage', true),
		),	
		
		'table_add' => array(
			array($table_prefix . 'affiliates_index_config', array(
					'COLUMNS'		=> array(
						'config_name'		=> array('VCHAR', ''),
						'config_value'		=> array('VCHAR_UNI', ''),
					),
					'PRIMARY_KEY'	=> 'config_name',
				),
			),
			
			array($table_prefix . 'affiliates_index_minibanners', array(
				'COLUMNS'	=> array(
					'minibanners_id'			=> array('UINT', NULL, 'auto_increment'),
					'minibanners_img'			=> array('VCHAR', ''),
					'minibanners_url'			=> array('VCHAR', ''),
					'minibanners_description'	=> array('VCHAR', ''),
				),
				'PRIMARY_KEY' => array('minibanners_id'), 
			    ),
			),

			array($table_prefix . 'affiliates_index_links', array(
				'COLUMNS'	=> array(
					'links_id'			=> array('UINT', NULL, 'auto_increment'),
					'links_img'			=> array('VCHAR', ''),
					'links_name'		=> array('VCHAR', ''),
					'links_url'			=> array('VCHAR', ''),
					'links_view'		=> array('VCHAR', ''),
					'links_order'		=> array('UINT', '0'),
				),
				'PRIMARY_KEY' => array('links_id'),
				'KEY' => array('links_order', ('links_order')), 
			    ),
			),		
		),		

		// Alright, now lets add some modules to the ACP
		'module_add' => array(
			// Aadimos la categoria ACP_AFFILIATES_INDEX_INFO a ACP_CAT_DOT_MODS
			array('acp', 'ACP_CAT_DOT_MODS', 'ACP_AFFILIATES_INDEX_INFO'),

			// Aadimos el modulo de general en la categoria  ACP_AFFILIATES_INDEX_INFO
			array('acp', 'ACP_AFFILIATES_INDEX_INFO', array(
					'module_basename'	=> 'affiliates_index',
					'module_langname'	=> 'ACP_AFFILIATES_INDEX_GENERAL_INFO',
					'module_mode'		=> 'general',
					'module_auth'		=> 'acl_a_affiliates_index_manage',
				),
			),

			// Aadimos el modulo de minibanners en la categoria ACP_AFFILIATES_INDEX_INFO
			array('acp', 'ACP_AFFILIATES_INDEX_INFO', array(
					'module_basename'	=> 'affiliates_index',
					'module_langname'	=> 'ACP_AFFILIATES_INDEX_MINIBANNERS_INFO',
					'module_mode'		=> 'minibanners',
					'module_auth'		=> 'acl_a_affiliates_index_manage',
				),
			),

			// Aadimos el modulo de enlaces en la categoria ACP_AFFILIATES_INDEX_INFO
			array('acp', 'ACP_AFFILIATES_INDEX_INFO', array(
					'module_basename'	=> 'affiliates_index',
					'module_langname'	=> 'ACP_AFFILIATES_INDEX_LINKS_INFO',
					'module_mode'		=> 'links',
					'module_auth'		=> 'acl_a_affiliates_index_manage',
				),
			),

			// Aadimos el modulo de enlacenos en la categoria ACP_AFFILIATES_INDEX_INFO
			array('acp', 'ACP_AFFILIATES_INDEX_INFO', array(
					'module_basename'	=> 'affiliates_index',
					'module_langname'	=> 'ACP_AFFILIATES_INDEX_LINKS_US_INFO',
					'module_mode'		=> 'link_us',
					'module_auth'		=> 'acl_a_affiliates_index_manage',
				),
			),
		),
		'cache_purge' => '',		
		'custom'	=> 'first_fill_0_0_1',
	),
	
	// nothing new here
	'0.0.2'	=>	array(
	'cache_purge' => '',
	'custom' => 'fill_0_0_2',
	),
	'0.0.3'	=>	array(
	'cache_purge' => '',
	'custom' => 'fill_0_0_3',
	),
	'0.0.4'	=>	array(
	'cache_purge' => '',
	'custom' => 'fill_0_0_4',
	),
	'0.0.5'	=>	array(
	'cache_purge' => '',
	'custom' => 'fill_0_0_5',
	),
	'0.0.6'	=>	array(
	'cache_purge' => '',
	'custom' => 'fill_0_0_6',
	),	
 	'0.0.7' => array(
	'cache_purge' => '',
	'custom'	=> 'fill_0_0_7',
	),
);

// Include the UMIF Auto file and everything else will be handled automatically.
include($phpbb_root_path . 'umil/umil_auto.' . $phpEx);

/*
* Here is our custom function that will be called for version 0.0.1
*
* @param string $action The action (install|update|uninstall) will be sent through this.
* @param string $version The version this is being run for will be sent through this.
*/
function first_fill_0_0_1($action, $version)
{
	global $db, $table_prefix, $umil;

	switch ($action)
	{
		case 'install' :    
			// Run this when installing the first time

			if ($umil->table_exists($table_prefix . 'affiliates_index_config'))
			{
				// before we fill anything in this table, we truncate it. Maybe someone missed an old installation.
				$db->sql_query('TRUNCATE TABLE ' . $table_prefix . 'affiliates_index_config');

				$sql_ary = array();

				$sql_ary[] = array('config_name' => 'affiliates_index_enable',				'config_value' => '1',);
				$sql_ary[] = array('config_name' => 'affiliates_index_minibanners',			'config_value' => '1',);
				$sql_ary[] = array('config_name' => 'affiliates_index_links',				'config_value' => '1',);
				$sql_ary[] = array('config_name' => 'affiliates_index_link_us',				'config_value' => '1',);
				$sql_ary[] = array('config_name' => 'version_check_time',				    'config_value' => '0',);
				$sql_ary[] = array('config_name' => 'version_check_version',				'config_value' => '0.0.0',);
				$sql_ary[] = array('config_name' => 'affiliates_index_version',				'config_value' => '0.0.1',);
				$sql_ary[] = array('config_name' => 'affiliates_index_version_check',		'config_value' => '1',);
				$sql_ary[] = array('config_name' => 'my_minibanner',						'config_value' => 'images/minibanners/my_minibanner.gif',);

				$db->sql_multi_insert($table_prefix . 'affiliates_index_config ', $sql_ary);
			}

  			if ($umil->table_exists($table_prefix . 'affiliates_index_minibanners'))
			{
				$sql = "INSERT INTO " . $table_prefix . "affiliates_index_minibanners (minibanners_id, minibanners_url, minibanners_img, minibanners_description, minibanners_order) VALUES (1, 'http://www.ivemfinity.com/', 'images/minibanners/banner_d.gif', 'Software libre, phpBB3, tutoriales, musica y mucho mas', 0)";
				$db->sql_query($sql);
				
				$sql = "INSERT INTO " . $table_prefix . "affiliates_index_minibanners (minibanners_id, minibanners_url, minibanners_img, minibanners_description, minibanners_order) VALUES (2, 'http://www.mundoforeros.com/', 'images/minibanners/mini_mun.gif', 'Torneos en Mundijuegos', 1)";
				$db->sql_query($sql);

				$sql = "INSERT INTO " . $table_prefix . "affiliates_index_minibanners (minibanners_id, minibanners_url, minibanners_img, minibanners_description, minibanners_order) VALUES (3, 'http://www.portalxl.nl/', 'images/minibanners/portalxl.png', 'Portalxl.nl', 2)";
				$db->sql_query($sql);

				$sql = "INSERT INTO " . $table_prefix . "affiliates_index_minibanners (minibanners_id, minibanners_url, minibanners_img, minibanners_description, minibanners_order) VALUES (4, 'http://www.phpbb.com/', 'images/minibanners/phpBB.gif', 'phpBB.com', 3)";
				$db->sql_query($sql);

				$sql = "INSERT INTO " . $table_prefix . "affiliates_index_minibanners (minibanners_id, minibanners_url, minibanners_img, minibanners_description, minibanners_order) VALUES (5, 'http://www.phpbb-es.com/', 'images/minibanners/banner_phpbb_es.png', 'phpBB castellano, hispano', 4)";
				$db->sql_query($sql);				
			}  

  			if ($umil->table_exists($table_prefix . 'affiliates_index_links'))
			{
				$sql = "INSERT INTO " . $table_prefix . "affiliates_index_links (links_id, links_img, links_name, links_url, links_view, links_order) VALUES (1, 'square_orange.gif', 'Ivemfinity', 'http://www.ivemfinity.com/', '1', 1)";
				$db->sql_query($sql);
				
				$sql = "INSERT INTO " . $table_prefix . "affiliates_index_links (links_id, links_img, links_name, links_url, links_view, links_order) VALUES (2, 'square_red.gif', 'Mundoforeros', 'http://www.mundoforeros.com/', '1', 2)";
				$db->sql_query($sql);
				
				$sql = "INSERT INTO " . $table_prefix . "affiliates_index_links (links_id, links_img, links_name, links_url, links_view, links_order) VALUES (3, 'square_green.gif', 'Board3.de', 'http://www.board3.de/', '1', 3)";
				$db->sql_query($sql);

				$sql = "INSERT INTO " . $table_prefix . "affiliates_index_links (links_id, links_img, links_name, links_url, links_view, links_order) VALUES (4, 'square_yellow.gif', 'Portalxl.nl', 'http://www.portalxl.nl/', '1', 4)";
				$db->sql_query($sql);

				$sql = "INSERT INTO " . $table_prefix . "affiliates_index_links (links_id, links_img, links_name, links_url, links_view, links_order) VALUES (5, 'square_brown.gif', 'phpBB-es', 'http://www.phpbb-es.com/', '1', 5)";
				$db->sql_query($sql);

				$sql = "INSERT INTO " . $table_prefix . "affiliates_index_links (links_id, links_img, links_name, links_url, links_view, links_order) VALUES (6, 'square_blue.gif', 'phpBB.com', 'http://www.phpbb.com/', '1', 6)";
				$db->sql_query($sql);				
			}			

			// Send the message, that the command was successful
			return 'UP_INSERT_FIRST_FILL';
		break;

		case 'update' :
		break;

 		case 'uninstall' :
			// Run this additionally when uninstalling

			// Send the message, that the command was successful
			return 'UP_REMOVE_AFFILIATES_ENTRIES';
		break;
	}
}

/*
* Here is our custom function that will be called for version 0.0.2
*
* @param string $action The action (install|update|uninstall) will be sent through this.
* @param string $version The version this is being run for will be sent through this.
*/
function fill_0_0_2($action, $version)
{
	global $db, $table_prefix, $umil;

	switch ($action)
	{
		case 'install' :
		case 'update' :
			// Run this when installing/updating						
			if ($umil->table_exists($table_prefix . 'affiliates_index_config'))
			{				
	            $sql = 'UPDATE ' . $table_prefix . "affiliates_index_config
		            SET config_value = '0.0.2'
		            WHERE config_name = 'affiliates_index_version'";			
				$db->sql_query($sql);				
			}
			
			// Method 1 of displaying the command (and Success for the result)
			return 'UP_UPDATE_SUCCESFUL';
		break;

		case 'uninstall' :
			
			// Send the message, that the command was successful
			return 'UP_REMOVE_AFFILIATES_ENTRIES';
		break;
	}
}

/*
* Here is our custom function that will be called for version 0.0.3
*
* @param string $action The action (install|update|uninstall) will be sent through this.
* @param string $version The version this is being run for will be sent through this.
*/
function fill_0_0_3($action, $version)
{
	global $db, $table_prefix, $umil;

	switch ($action)
	{
		case 'install' :
		case 'update' :
			// Run this when installing/updating						
			if ($umil->table_exists($table_prefix . 'affiliates_index_config'))
			{				
	            $sql = 'UPDATE ' . $table_prefix . "affiliates_index_config
		            SET config_value = '0.0.3'
		            WHERE config_name = 'affiliates_index_version'";			
				$db->sql_query($sql);				
			}
			
			// Method 1 of displaying the command (and Success for the result)
			return 'UP_UPDATE_SUCCESFUL';
		break;

		case 'uninstall' :
			
			// Send the message, that the command was successful
			return 'UP_REMOVE_AFFILIATES_ENTRIES';
		break;
	}
}

/*
* Here is our custom function that will be called for version 0.0.4
*
* @param string $action The action (install|update|uninstall) will be sent through this.
* @param string $version The version this is being run for will be sent through this.
*/
function fill_0_0_4($action, $version)
{
	global $db, $table_prefix, $umil;

	switch ($action)
	{
		case 'install' :
		case 'update' :
			// Run this when installing/updating						
			if ($umil->table_exists($table_prefix . 'affiliates_index_config'))
			{				
	            $sql = 'UPDATE ' . $table_prefix . "affiliates_index_config
		            SET config_value = '0.0.4'
		            WHERE config_name = 'affiliates_index_version'";			
				$db->sql_query($sql);				
			}
			
			// Method 1 of displaying the command (and Success for the result)
			return 'UP_UPDATE_SUCCESFUL';
		break;

		case 'uninstall' :
			
			// Send the message, that the command was successful
			return 'UP_REMOVE_AFFILIATES_ENTRIES';
		break;
	}
}

/*
* Here is our custom function that will be called for version 0.0.5
*
* @param string $action The action (install|update|uninstall) will be sent through this.
* @param string $version The version this is being run for will be sent through this.
*/
function fill_0_0_5($action, $version)
{
	global $db, $table_prefix, $umil;

	switch ($action)
	{
		case 'install' :
		case 'update' :
			// Run this when installing/updating						
			if ($umil->table_exists($table_prefix . 'affiliates_index_config'))
			{				
	            $sql = 'UPDATE ' . $table_prefix . "affiliates_index_config
		            SET config_value = '0.0.5'
		            WHERE config_name = 'affiliates_index_version'";			
				$db->sql_query($sql);				
			}
			
			// Method 1 of displaying the command (and Success for the result)
			return 'UP_UPDATE_SUCCESFUL';
		break;

		case 'uninstall' :
			
			// Send the message, that the command was successful
			return 'UP_REMOVE_AFFILIATES_ENTRIES';
		break;
	}
}

/*
* Here is our custom function that will be called for version 0.0.6
*
* @param string $action The action (install|update|uninstall) will be sent through this.
* @param string $version The version this is being run for will be sent through this.
*/
function fill_0_0_6($action, $version)
{
	global $db, $table_prefix, $umil;

	switch ($action)
	{
		case 'install' :
		case 'update' :
			// Run this when installing/updating
 			if ($umil->table_exists($table_prefix . 'affiliates_index_minibanners'))
			{
	            $sql = "DROP TABLE " . $table_prefix . "affiliates_index_minibanners";			
				$db->sql_query($sql);

	            $sql = "CREATE TABLE " . $table_prefix . "affiliates_index_minibanners (
				    minibanners_id smallint(5) unsigned NOT NULL AUTO_INCREMENT,
                    minibanners_url varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL,
					minibanners_img varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL,
					minibanners_description varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
					minibanners_order mediumint(8) unsigned NOT NULL DEFAULT '0',
					PRIMARY KEY (minibanners_id),
					KEY minibanners_order (minibanners_order)
				)";					
				$db->sql_query($sql);				

				$sql = "INSERT INTO " . $table_prefix . "affiliates_index_minibanners (minibanners_id, minibanners_url, minibanners_img, minibanners_description, minibanners_order) VALUES (1, 'http://www.ivemfinity.com/', 'images/minibanners/banner_d.gif', 'Software libre, phpBB3, tutoriales, musica y mucho mas', 0)";
				$db->sql_query($sql);
				
				$sql = "INSERT INTO " . $table_prefix . "affiliates_index_minibanners (minibanners_id, minibanners_url, minibanners_img, minibanners_description, minibanners_order) VALUES (2, 'http://www.mundoforeros.com/', 'images/minibanners/mini_mun.gif', 'Torneos en Mundijuegos', 1)";
				$db->sql_query($sql);

				$sql = "INSERT INTO " . $table_prefix . "affiliates_index_minibanners (minibanners_id, minibanners_url, minibanners_img, minibanners_description, minibanners_order) VALUES (3, 'http://www.portalxl.nl/', 'images/minibanners/portalxl.png', 'Portalxl.nl', 2)";
				$db->sql_query($sql);

				$sql = "INSERT INTO " . $table_prefix . "affiliates_index_minibanners (minibanners_id, minibanners_url, minibanners_img, minibanners_description, minibanners_order) VALUES (4, 'http://www.phpbb.com/', 'images/minibanners/phpBB.gif', 'phpBB.com', 3)";
				$db->sql_query($sql);

				$sql = "INSERT INTO " . $table_prefix . "affiliates_index_minibanners (minibanners_id, minibanners_url, minibanners_img, minibanners_description, minibanners_order) VALUES (5, 'http://www.phpbb-es.com/', 'images/minibanners/banner_phpbb_es.png', 'phpBB castellano, hispano', 4)";
				$db->sql_query($sql);

				$sql = "ALTER TABLE " . $table_prefix . "affiliates_index_minibanners CHARACTER SET utf8 COLLATE utf8_bin";
				$db->sql_query($sql);				
			} 
			
			if ($umil->table_exists($table_prefix . 'affiliates_index_config'))
			{
	            $sql = 'UPDATE ' . $table_prefix . "affiliates_index_config
		            SET config_value = '0.0.6'
		            WHERE config_name = 'affiliates_index_version'";			
				$db->sql_query($sql);
				
				$sql = "INSERT INTO " . $table_prefix . "affiliates_index_config
					(`config_name`, `config_value`) VALUES ('minibanners_title_name', 'Minibanners')";
				$db->sql_query($sql);

				$sql = "INSERT INTO " . $table_prefix . "affiliates_index_config
					(`config_name`, `config_value`) VALUES ('minibanners_width', '88')";
				$db->sql_query($sql);

				$sql = "INSERT INTO " . $table_prefix . "affiliates_index_config
					(`config_name`, `config_value`) VALUES ('minibanners_height', '31')";
				$db->sql_query($sql);

				$sql = "INSERT INTO " . $table_prefix . "affiliates_index_config
					(`config_name`, `config_value`) VALUES ('minibanners_vel', '20')";
				$db->sql_query($sql);

				$sql = "INSERT INTO " . $table_prefix . "affiliates_index_config
					(`config_name`, `config_value`) VALUES ('links_title_name', 'Enlaces')";
				$db->sql_query($sql);

				$sql = "INSERT INTO " . $table_prefix . "affiliates_index_config
					(`config_name`, `config_value`) VALUES ('links_vel', '20')";
				$db->sql_query($sql);	

				$sql = "INSERT INTO " . $table_prefix . "affiliates_index_config
					(`config_name`, `config_value`) VALUES ('link_us_title_name', 'Enlacenos')";
				$db->sql_query($sql);		
			}			
			
			// Method 1 of displaying the command (and Success for the result)
			return 'UP_UPDATE_SUCCESFUL';
		break;

		case 'uninstall' :
			
			// Send the message, that the command was successful
			return 'UP_REMOVE_AFFILIATES_ENTRIES';
		break;
	}
}

/*
* Here is our custom function that will be called for version 0.0.7
*
* @param string $action The action (install|update|uninstall) will be sent through this.
* @param string $version The version this is being run for will be sent through this.
*/
function fill_0_0_7($action, $version)
{
	global $db, $table_prefix, $umil;

	switch ($action)
	{
		case 'install' :
		case 'update' :
			// Run this when installing/updating
 			if ($umil->table_exists($table_prefix . 'affiliates_index_minibanners'))
			{
				$sql = "ALTER TABLE " . $table_prefix . "affiliates_index_minibanners CHARACTER SET utf8 COLLATE utf8_bin";
				$db->sql_query($sql);				
				
			} 
			
 			if ($umil->table_exists($table_prefix . 'affiliates_index_links'))
			{

				$sql = "ALTER TABLE " . $table_prefix . "affiliates_index_links CHARACTER SET utf8 COLLATE utf8_bin";
				$db->sql_query($sql);				
				
			}			
			
			if ($umil->table_exists($table_prefix . 'affiliates_index_config'))
			{
	            $sql = 'UPDATE ' . $table_prefix . "affiliates_index_config
		            SET config_value = '0.0.7'
		            WHERE config_name = 'affiliates_index_version'";			
				$db->sql_query($sql);				

				$sql = 'DELETE FROM ' . $table_prefix . "affiliates_index_config
					WHERE config_name = 'minibanners_vel'";
				$db->sql_query($sql);
				
				$sql = 'DELETE FROM ' . $table_prefix . "affiliates_index_config
					WHERE config_name = 'links_vel'";
				$db->sql_query($sql);				
			}
			
			// Method 1 of displaying the command (and Success for the result)
			return 'UP_UPDATE_SUCCESFUL';
		break;

		case 'uninstall' :
			
			// Send the message, that the command was successful
			return 'UP_REMOVE_AFFILIATES_ENTRIES';
		break;
	}
}

?>