<?php

/**
*
* @package - Affiliates on index
* @version $Id: acp_affiliates_index.php 63 2010-28-09 05:28:52Z jakk $
* @copyright (c) jakk ( www.ivemfinity.com/ )
* @based on: Board3 portal by (c) kevin / saint ( www.board3.de/ ), (c) Ice, (c) nickvergessen ( www.flying-bits.org/ ), (c) redbull254 ( www.digitalfotografie-foren.de ), (c) Christian_N ( www.phpbb-projekt.de )
* @license http://opensource.org/licenses/gpl-license.php GNU Public License 
*
*/

if (!defined('IN_PHPBB'))
{
	exit;
}

class acp_affiliates_index
{
	var $u_action;
	var $new_config = array();

	function main($id, $mode)
	{
		global $db, $user, $template;
		global $config, $affiliates_index_config, $phpbb_root_path, $phpbb_admin_path, $phpEx;

		include($phpbb_root_path . 'includes/affiliates_index/functions_affiliates_index.' . $phpEx);

		$affiliates_index_config = obtain_affiliates_index_config();

		$user->add_lang('mods/acp_affiliates_index');
		

		if (!function_exists('mod_version_check'))
		{
			include($phpbb_root_path . 'includes/affiliates_index/functions_version_check.' . $phpEx);
		}
		mod_version_check();
		
		// Set up general vars
		$action = request_var('action', '');
		$action = (isset($_POST['edit'])) ? 'edit' : $action;
		$action = (isset($_POST['add'])) ? 'add' : $action;
		$action = (isset($_POST['save'])) ? 'save' : $action;
		$submit = (isset($_POST['submit'])) ? true : false;
		$minibanners_id = request_var('id', 0);
		$minibanners_order = request_var('id', 0);
		$links_id = request_var('id', 0);
		$links_order = request_var('id', 0);
        $ord = request_var('ord',0);
        $ord2 = request_var('ord2',0);
        $id = request_var('id',0);
        $id2 = request_var('id2',0);
		$table = AFFILIATES_INDEX_LINKS_TABLE;

		$this->new_config = $affiliates_index_config;

		/**
		*	Validation types are:
		*		string, int, bool,
		*		script_path (absolute path in url - beginning with / and no trailing slash),
		*		rpath (relative), rwpath (realtive, writeable), path (relative path, but able to escape the root), wpath (writeable)
		*/
		switch ($mode)
		{
			case 'general':
				$display_vars = array(
					'title'	=> 'ACP_AFFILIATES_INDEX_GENERAL_TITLE',
					'vars'	=> array(
						'legend1'					=> 'ACP_AFFILIATES_INDEX_GENERAL_SETTINGS',
						'affiliates_index_enable'				=> array('lang' => 'ACP_AFFILIATES_INDEX_ENABLE',				'validate' => 'bool',	'type' => 'radio:yes_no',	'explain' => true),
						'affiliates_index_version_check'		=> array('lang' => 'ACP_AFFILIATES_INDEX_VERSION_CHECK',		'validate' => 'bool',	'type' => 'radio:yes_no',	'explain' => true),
						'affiliates_index_minibanners'			=> array('lang' => 'ACP_AFFILIATES_INDEX_MINIBANNERS', 'validate' => 'bool', 'type' => 'radio:yes_no', 'explain' => true),
						'affiliates_index_links'				=> array('lang' => 'ACP_AFFILIATES_INDEX_LINKS', 'validate' => 'bool', 'type' => 'radio:yes_no', 'explain' => true),
						'affiliates_index_link_us'			    => array('lang' => 'ACP_AFFILIATES_INDEX_LINK_US',						'validate' => 'bool',	'type' => 'radio:yes_no',	'explain' => true),
					)
				);
			    $this->tpl_name = 'acp_affiliates_index';
		        $this->page_title = $display_vars['title'];
		        $title_explain = $user->lang[$display_vars['title'] . '_EXPLAIN'];						
			break;
			
			case 'link_us':
				$display_vars = array(
					'title'	=> 'ACP_AFFILIATES_INDEX_LINK_US_TITLE',
					'vars'	=> array(
						'legend1'					=> 'ACP_AFFILIATES_INDEX_LINKS_US_SETTINGS',
                        'link_us_title_name'        => array('lang' => 'ACP_AFFILIATES_INDEX_LINK_US_TITLE_NAME',	'validate' => 'string',		'type' => 'text:25:100',	 'explain' => true),
						'my_minibanner'		        => array('lang' => 'ACP_AFFILIATES_INDEX_MY_MINIBANNER',		'validate' => 'string',		'type' => 'text:40:255',	'explain'	=> true),
					)
				);
			    $this->tpl_name = 'acp_affiliates_index_link_us';
		        $this->page_title = $display_vars['title'];
		        $title_explain = $user->lang[$display_vars['title'] . '_EXPLAIN'];

			$template->assign_vars(array(
				'MY_MINIBANNER_PREVIEW'       =>  '<img src="../' . $affiliates_index_config['my_minibanner'] . '" />',
				'L_ACP_MY_MINIBANNER_PREVIEW' => $user->lang['ACP_MY_MINIBANNER_PREVIEW'],
			));
	
			break;			
		
			case 'minibanners':
				$display_vars = array(
					'title'	=> 'ACP_AFFILIATES_INDEX_MINIBANNERS_SETTINGS',
					'vars'	=> array(
						'legend1'					=> 'ACP_AFFILIATES_INDEX_MINIBANNERS_SETTINGS',                                               
						'minibanners_title_name' => array('lang' => 'ACP_AFFILIATES_INDEX_MINIBANNERS_TITLE_NAME',	'validate' => 'string',		'type' => 'text:25:100',	 'explain' => true),
						'minibanners_width' => array('lang' => 'ACP_AFFILIATES_INDEX_MINIBANNERS_WIDTH',	'validate' => 'int',		'type' => 'text:3:3',		 'explain' => true),
					    'minibanners_height' => array('lang' => 'ACP_AFFILIATES_INDEX_MINIBANNERS_HEIGTH',	'validate' => 'int',		'type' => 'text:3:3',		 'explain' => true),
					)
				);	
			    $this->tpl_name = 'acp_affiliates_index_minibanners';
		        $this->page_title = $display_vars['title']; 
		        $title_explain = $user->lang[$display_vars['title'] . '_EXPLAIN'];				
			
		        switch ($action)
		        {
				
		            case 'save':

                        $minibanners_id 			= request_var('id', '', true);
				        $minibanners_img 			= request_var('minibanners_img', '', true);
				        $minibanners_description 	= request_var('minibanners_description', '', true);				
				        $minibanners_url 			= request_var('minibanners_url', '', true);
					    $minibanners_order 	        = request_var('minibanners_order', '', true);
					
                    $sqlnews = 'SELECT MAX(minibanners_order) as total_minibanners_order
                       FROM ' . AFFILIATES_INDEX_MINIBANNERS_TABLE . '
                       WHERE minibanners_order ';
                    $resultnews = $db->sql_query($sqlnews);
                    $total_minibanners_order = (int) $db->sql_fetchfield('total_minibanners_order');
                    $db->sql_freeresult($resultnews);
                    if($minibanners_order) { $minibanners_order = $minibanners_order; } 
					else 
					{
                       $minibanners_order = $total_minibanners_order + 1;           
                    } 					

				        $sql_ary = array(
                            'minibanners_id'			=> $minibanners_id,
					        'minibanners_img'			=> $minibanners_img,
					        'minibanners_description'	=> $minibanners_description,					
					        'minibanners_url'			=> $minibanners_url,
						    'minibanners_order'	        => $minibanners_order
				        );

				        if ($minibanners_id)
				        {
				            $sql = 'UPDATE ' . AFFILIATES_INDEX_MINIBANNERS_TABLE . ' SET ' . $db->sql_build_array('UPDATE', $sql_ary) . " WHERE minibanners_id = $minibanners_id";
				            $message = $user->lang['MINIBANNERS_UPDATED'];
				        }
				        else
				        {
				            $sql = 'INSERT INTO ' . AFFILIATES_INDEX_MINIBANNERS_TABLE . ' ' . $db->sql_build_array('INSERT', $sql_ary);
				            $message = $user->lang['MINIBANNERS_ADDED'];
				        }
				        $db->sql_query($sql);

				        trigger_error($message . adm_back_link($this->u_action));

			        break;

			        case 'delete':

				        // Ok, they want to delete their quote
				        if ($minibanners_id)
				        {
					        $sql = 'DELETE FROM ' . AFFILIATES_INDEX_MINIBANNERS_TABLE . "
						    WHERE minibanners_id = $minibanners_id";
					        $db->sql_query($sql);

					        trigger_error($user->lang['MINIBANNERS_REMOVED'] . adm_back_link($this->u_action));
				        }
				        else
				        {
					        trigger_error($user->lang['MUST_SELECT_MINIBANNERS'] . adm_back_link($this->u_action), E_USER_WARNING);
				        }
				
			        break;
                    case 'move_down':
                    case 'move_up':

                        $sql = 'UPDATE ' . AFFILIATES_INDEX_MINIBANNERS_TABLE  . ' SET minibanners_order=' . $ord .' + '. $ord2 .' - minibanners_order WHERE minibanners_id = ' . $id .' OR minibanners_id = ' . $id2 . '';
                        if( !($result = $db->sql_query($sql)) )
                        $db->sql_query($sql);
			         break;				

			        case 'edit':
			        case 'add':
					
				        $sql = 'SELECT *
					    FROM ' . AFFILIATES_INDEX_MINIBANNERS_TABLE . '
					    ORDER BY   minibanners_url ASC';
				        $result = $db->sql_query($sql);

				        while ($row = $db->sql_fetchrow($result))
				        {

 				           if ($action == 'edit' && $minibanners_id == $row['minibanners_id'])

					       {
						       $minibanners_url = $row;
						       $minibanners_img = $row;
						       $minibanners_description = $row;
						       $minibanners_order = $row;
					       }
				        }
                        $db->sql_freeresult($result);				        

				        $template->assign_vars(array(
					        'S_EDIT'				=> true,
					        'U_BACK'				=> $this->u_action,
					        'U_ACTION'				=> $this->u_action . '&amp;id=' . $minibanners_id,
						    'MINIBANNERS_ORDER' 	=> (isset($minibanners_order['minibanners_order'])) ? $minibanners_order['minibanners_order'] : '',
					        'MINIBANNERS_URL'			=> (isset($minibanners_url['minibanners_url'])) ? $minibanners_url['minibanners_url'] : '',
					        'MINIBANNERS_DESCRIPTION'	=> (isset($minibanners_description['minibanners_description'])) ? $minibanners_description['minibanners_description'] : '',					
					        'MINIBANNERS_IMG'			=> (isset($minibanners_img['minibanners_img'])) ? $minibanners_img['minibanners_img'] : '')
				        );

				        return;
	
			        break;
			
		        }
	
		                $template->assign_vars(array(
			                'U_ACTION'		=> $this->u_action)
		                );
				
				

		                $sql = 'SELECT *
			               FROM ' . AFFILIATES_INDEX_MINIBANNERS_TABLE . '
			               ORDER BY minibanners_order ASC';
		                $result = $db->sql_query($sql);
				{
                $nb_menu = 0 ;				

		            while ($row = $db->sql_fetchrow($result))
		            {
                        $minibanners_block[$nb_menu]['minibanners_id'] 		=  $row['minibanners_id'] ;
                        $minibanners_block[$nb_menu]['minibanners_order'] 	=  $row['minibanners_order'] ;
                        $minibanners_block[$nb_menu]['minibanners_url'] 	=  $row['minibanners_url'] ;
                        $minibanners_block[$nb_menu]['minibanners_description'] 	=  $row['minibanners_description'] ;
                        $minibanners_block[$nb_menu]['minibanners_img'] 	=  '<div style="margin:2px;"><img src="../' . $row['minibanners_img'] . '" width="' . $affiliates_index_config['minibanners_width'] . '" height="' . $affiliates_index_config['minibanners_height'] . '" alt="' . $row['minibanners_description'] . '" title="' . $row['minibanners_description'] . '" /></div>' ;					
                        $nb_menu ++ ;
				    }
		            for ( $affiliates_index_minibanners_block = 0 ; $affiliates_index_minibanners_block < $nb_menu ; $affiliates_index_minibanners_block ++)	
			                $template->assign_block_vars('minibanners', array(
                                'MINIBANNERS_ORDER'       =>  $minibanners_block[$affiliates_index_minibanners_block]['minibanners_order'],
                                'MINIBANNERS_URL'         =>  $minibanners_block[$affiliates_index_minibanners_block]['minibanners_url'],
                                'MINIBANNERS_DESCRIPTION' =>  $minibanners_block[$affiliates_index_minibanners_block]['minibanners_description'],
                                'MINIBANNERS_IMG'         =>  $minibanners_block[$affiliates_index_minibanners_block]['minibanners_img'],				
                                'U_MOVE_UP'     =>  $this->u_action . '&amp;action=move_up&amp;idnone=' . $minibanners_block[$affiliates_index_minibanners_block]['minibanners_id']."&amp;id2="  . $minibanners_block[$affiliates_index_minibanners_block - 1]['minibanners_id'] . "&amp;id=" .  $minibanners_block[$affiliates_index_minibanners_block]['minibanners_id']. "&amp;ord=" .  $minibanners_block[$affiliates_index_minibanners_block]['minibanners_order'] . "&amp;ord2=" .  $minibanners_block[$affiliates_index_minibanners_block - 1]['minibanners_order'],
                                'U_MOVE_DOWN'   =>  $this->u_action . '&amp;action=move_down&amp;idnone=' . $minibanners_block[$affiliates_index_minibanners_block]['minibanners_id']."&amp;id2="  . $minibanners_block[$affiliates_index_minibanners_block + 1]['minibanners_id']  . "&amp;id=" .  $minibanners_block[$affiliates_index_minibanners_block]['minibanners_id'] . "&amp;ord=" .  $minibanners_block[$affiliates_index_minibanners_block]['minibanners_order'] . "&amp;ord2=" .  $minibanners_block[$affiliates_index_minibanners_block + 1]['minibanners_order'],
				                'U_EDIT'	    => 	$this->u_action . '&amp;action=edit&amp;id=' . $minibanners_block[$affiliates_index_minibanners_block]['minibanners_id']."&amp;id="  . $minibanners_block[$affiliates_index_minibanners_block]['minibanners_id'],
				                'U_DELETE'		=> 	$this->u_action . '&amp;action=delete&amp;id=' . $minibanners_block[$affiliates_index_minibanners_block]['minibanners_id']."&amp;id="  . $minibanners_block[$affiliates_index_minibanners_block]['minibanners_id'])
			               );
		                }	
                    break;	
					
			case 'links':		
				$display_vars = array(
					'title'	=> 'ACP_AFFILIATES_INDEX_LINKS_SETTINGS',
					'vars'	=> array(
						'legend1'							=> 'ACP_AFFILIATES_INDEX_LINKS_SETTINGS',
						'links_title_name' => array('lang' => 'ACP_AFFILIATES_INDEX_LINKS_TITLE_NAME',	'validate' => 'string',		'type' => 'text:25:100',	 'explain' => true),
					)
				);	
			   $this->tpl_name = 'acp_affiliates_index_links';
		       $this->page_title = $display_vars['title'];
		       $title_explain = $user->lang[$display_vars['title'] . '_EXPLAIN'];	
			   
		        switch ($action)
		        {	

		           case 'save':
                    $links_id     	= request_var('id', '', true);		
				    $links_img 		= request_var('links_img', '', true);
				    $links_name 	= request_var('links_name', '', true);
				    $links_url 		= request_var('links_url', '', true);
				    $links_view 	= request_var('links_view', '', true);
				    $links_order 	= request_var('links_order', '', true);
				
                    $sqlnews = 'SELECT MAX(links_order) as total_links_order
                       FROM ' . AFFILIATES_INDEX_LINKS_TABLE . '
                       WHERE links_order ';
                    $resultnews = $db->sql_query($sqlnews);
                    $total_links_order = (int) $db->sql_fetchfield('total_links_order');
                    $db->sql_freeresult($resultnews);
                    if($links_order) { $links_order = $links_order; } 
					else 
					{
                       $links_order = $total_links_order + 1;           
                    } 					
				
				    $sql_ary 		= array(
					    'links_id'      => $links_id, 
					    'links_img'		=> $links_img,
                        'links_name'	=> $links_name,
					    'links_url'		=> $links_url,
                        'links_view'	=> $links_view,
                        'links_order'	=> $links_order,					
				    );

				    if ($links_id)
				    {
				        $sql = 'UPDATE ' . AFFILIATES_INDEX_LINKS_TABLE  . ' SET ' . $db->sql_build_array('UPDATE', $sql_ary) . " WHERE links_id = $links_id";
				        $message = $user->lang['LINKS_UPDATED'];
				    }
				    else
				    {
				        $sql = 'INSERT INTO ' . AFFILIATES_INDEX_LINKS_TABLE  . ' ' . $db->sql_build_array('INSERT', $sql_ary);
				        $message = $user->lang['LINKS_ADDED'];
				    }
				    $db->sql_query($sql);

				    trigger_error($message . adm_back_link($this->u_action));

			        break;

			        case 'delete':
				       if ($links_id)
				       {
					       $sql = 'DELETE FROM ' . AFFILIATES_INDEX_LINKS_TABLE . "
						      WHERE links_id = $links_id";
					        $db->sql_query($sql);

					         trigger_error($user->lang['LINKS_REMOVED'] . adm_back_link($this->u_action));
				        }
				        else
				        {
					         trigger_error($user->lang['MUST_SELECT_LINKS'] . adm_back_link($this->u_action), E_USER_WARNING);
				        }

			         break;

			        case 'edit':
			        case 'add':
		
				        $sql = "SELECT *
					       FROM $table
					       ORDER BY links_name ASC";
				        $result = $db->sql_query($sql);
				        while ($row = $db->sql_fetchrow($result))
				        {
 				           if ($action == 'edit' && $links_id == $row['links_id'])
					       {
						       $links_img = $row;
						       $links_name = $row;
						       $links_url = $row;
						       $links_view = $row;
						       $links_order = $row;						
					        }
				        }
				        $db->sql_freeresult($result);
						
				/*
				* Get all icons we need from their directory
				*/
				if ($dir = opendir($phpbb_root_path . 'images/icon_links')) {
					$links_images = array();
					while (($file = readdir($dir)) !== false) {
						if (preg_match('#^[^&\'"<>]+\.(?:gif|png|jpe?g)$#i', $file)) {
							$links_images[$file] = array(
								'file'	=> $file,
								'name'	=> ucfirst(str_replace('_', ' ', preg_replace('#^(.*)\..*$#', '\1', $file))),
							);
						}
    				}
    				closedir($dir);
					asort($links_images);
				}
				
				foreach ($links_images as $linksimages)
				{
						$template->assign_block_vars('file_name', array(
							'S_LINKS_IMG' 		=> $linksimages['file'],
							'S_LINKS_IMG_NAME' 	=> $linksimages['name'],
							));
				}				
				unset($links_images);

				/*
				* Get all icons for preview we need from their directory
				*/
				if ($dir = opendir($phpbb_root_path . 'images/icon_links')) {
					$imagescontent = array();
					while (($file = readdir($dir)) !== false) {
						if (preg_match('#^[^&\'"<>]+\.(?:gif|png|jpe?g)$#i', $file)) {
							$imagescontent[$file] = array(
								'file'	=> $file,
								'name'	=> ucfirst(str_replace('_', ' ', preg_replace('#^(.*)\..*$#', '\1', $file))),
							);
						}
    				}
    				closedir($dir);
					asort($imagescontent);
				}
				
				foreach ($imagescontent as $images)
				{
						$template->assign_block_vars('img_file_name_icon', array(
          					'S_BLOCK_FILE_NAME'  => $images['name'],
        					'S_BLOCK_FILE_ICON'  => '<img src="' . $phpbb_root_path . 'images/icon_links/' . $images['file'] . '" title="' . $images['name'] . '" height="15" width="15" alt="' . $images['name'] . '" />'
							));
				}				
				unset($imagescontent);					
				
				        $template->assign_vars(array(
					        'S_EDIT'	 	=> true,
					        'U_BACK'	 	=> $this->u_action,
					        'U_ACTION'	 	=> $this->u_action . '&amp;id=' . $links_id,
					        'LINKS_ORDER' 	=> (isset($links_order['links_order'])) ? $links_order['links_order'] : '',					
					        'LINKS_IMG'	 	=> (isset($links_img['links_img'])) ? $links_img['links_img'] : '',
					        'LINKS1_IMG'	=> $row['links_img'],
					        'S_IMAGE_FILE'	=> $row['links_img'],
					        'LINKS_NAME'	=> (isset($links_name['links_name'])) ? $links_name['links_name'] : '',
					        'LINKS_URL'	 	=> (isset($links_url['links_url'])) ? $links_url['links_url'] : '',
					        'LINKS_VIEW'	=> (isset($links_view['links_view'])) ? $links_view['links_view'] : ''	)
				        );
				        return;
			        break;
			
                    case 'move_down':
                    case 'move_up':

                        $sql = 'UPDATE ' . AFFILIATES_INDEX_LINKS_TABLE  . ' SET links_order=' . $ord .' + '. $ord2 .' - links_order WHERE links_id = ' . $id .' OR links_id = ' . $id2 . '';
                        if( !($result = $db->sql_query($sql)) )
                        $db->sql_query($sql); 
			         break;
		        }			
		
		        $template->assign_vars(array(
			    'U_ACTION'		=> $this->u_action)
		        );

		        $sql = 'SELECT *
			        FROM ' . AFFILIATES_INDEX_LINKS_TABLE  . '
			        ORDER BY links_order ASC ';
		        $result = $db->sql_query($sql);
		        {
			       $nb_menu = 0 ;		
			       while ( $row = $db->sql_fetchrow($result) )		
                   {
                       $links_block[$nb_menu]['links_id'] 		=  $row['links_id'] ;
                       $links_block[$nb_menu]['links_order'] 	=  $row['links_order'] ;
                       $links_block[$nb_menu]['links_view'] 	=  $row['links_view'] ;
                       $links_block[$nb_menu]['links_url'] 	=  $row['links_url'] ;
                       $links_block[$nb_menu]['links_name'] 	=  $row['links_name'] ;
                       $links_block[$nb_menu]['links_img'] 	=  $row['links_img'] ;;					
                       $nb_menu ++ ;
                    }
			        for ( $affiliates_index_links_block = 0 ; $affiliates_index_links_block < $nb_menu ; $affiliates_index_links_block ++)	
			        $template->assign_block_vars('links', array(				
				       'LINKS_ORDER'   =>  $links_block[$affiliates_index_links_block]['links_order'],
				       'LINKS_VIEW'    =>  $links_block[$affiliates_index_links_block]['links_view'],
				       'LINKS_URL'     =>  $links_block[$affiliates_index_links_block]['links_url'],				
				       'MEU_NAME'      =>  $links_block[$affiliates_index_links_block]['links_name'],
				       'LINKS_IMG'     =>  $links_block[$affiliates_index_links_block]['links_img'],	
				       'S_IMAGE_FILE'	=>  $links_block[$affiliates_index_links_block]['links_img'],
                       'U_MOVE_UP'     =>  $this->u_action . '&amp;action=move_up&amp;idnone=' . $links_block[$affiliates_index_links_block]['links_id']."&amp;id2="  . $links_block[$affiliates_index_links_block - 1]['links_id'] . "&amp;id=" .  $links_block[$affiliates_index_links_block]['links_id']. "&amp;ord=" .  $links_block[$affiliates_index_links_block]['links_order'] . "&amp;ord2=" .  $links_block[$affiliates_index_links_block - 1]['links_order'],
                       'U_MOVE_DOWN'   =>  $this->u_action . '&amp;action=move_down&amp;idnone=' . $links_block[$affiliates_index_links_block]['links_id']."&amp;id2="  . $links_block[$affiliates_index_links_block + 1]['links_id']  . "&amp;id=" .  $links_block[$affiliates_index_links_block]['links_id'] . "&amp;ord=" .  $links_block[$affiliates_index_links_block]['links_order'] . "&amp;ord2=" .  $links_block[$affiliates_index_links_block + 1]['links_order'],				
                       'U_DELETE'     	=>  $this->u_action . '&amp;action=delete&amp;id2=' . $links_block[$affiliates_index_links_block]['links_id']."&amp;id="  . $links_block[$affiliates_index_links_block]['links_id'],
                       'U_EDIT'        =>  $this->u_action . '&amp;action=edit&amp;id2=' . $links_block[$affiliates_index_links_block]['links_id']."&amp;id="  . $links_block[$affiliates_index_links_block]['links_id'])					
                    );	
		        }
		       $db->sql_freeresult($result);
            break;		
		}

		if (isset($display_vars['lang']))
		{
			$user->add_lang($display_vars['lang']);
		}

		$cfg_array = (isset($_REQUEST['config'])) ? utf8_normalize_nfc(request_var('config', array('' => ''), true)) : $this->new_config;
		$error = array();
		
		// We validate the complete config if whished
		validate_config_vars($display_vars['vars'], $cfg_array, $error);
		
		// Do not write values if there is an error
		if (sizeof($error))
		{
			$submit = false;
		}

		// We go through the display_vars to make sure no one is trying to set variables he/she is not allowed to...
		foreach ($display_vars['vars'] as $config_name => $null)
		{
			if (!isset($cfg_array[$config_name]) || strpos($config_name, 'legend') || ($mode == 'links' && strpos($config_name, 'affiliates_index_link_') ) !== false)
			{
				continue;
			}

			$this->new_config[$config_name] = $config_value = $cfg_array[$config_name];
			
			if ($submit)
			{
					set_affiliates_index_config($config_name, $config_value);									
			}			
		}
		
				
		if ($submit)
		{
			add_log('admin', 'LOG_AFFILIATES_INDEX_CONFIG', $user->lang['ACP_AFFILIATES_INDEX_' . strtoupper($mode) . '_INFO']);
			trigger_error($user->lang['ACP_AFFILIATES_INDEX_CONFIG_UPDATED'] . adm_back_link($this->u_action));
		}

		$template->assign_vars(array(
			'L_TITLE'			=> $user->lang[$display_vars['title']],
			'L_TITLE_EXPLAIN'	=> $title_explain,

			'S_ERROR'			=> (sizeof($error)) ? true : false,
			'ERROR_MSG'			=> implode('<br />', $error),

			'S_VERSIONCHECK'	=> ($display_vars['title'] == 'ACP_AFFILIATES_INDEX_GENERAL_TITLE') ? true : false,

			'U_ACTION'			=> $this->u_action)
		);

		// Output relevant page
		foreach ($display_vars['vars'] as $config_key => $vars)
		{
			if (!is_array($vars) && strpos($config_key, 'legend') === false)
			{
				continue;
			}

			if (strpos($config_key, 'legend') !== false)
			{
				$template->assign_block_vars('options', array(
					'S_LEGEND'		=> true,
					'LEGEND'		=> (isset($user->lang[$vars])) ? $user->lang[$vars] : $vars)
				);

				continue;
			}

			$type = explode(':', $vars['type']);

			$l_explain = '';
			if ($vars['explain'] && isset($vars['lang_explain']))
			{
				$l_explain = (isset($user->lang[$vars['lang_explain']])) ? $user->lang[$vars['lang_explain']] : $vars['lang_explain'];
			}
			else if ($vars['explain'])
			{
				$l_explain = (isset($user->lang[$vars['lang'] . '_EXPLAIN'])) ? $user->lang[$vars['lang'] . '_EXPLAIN'] : '';
			}

			$template->assign_block_vars('options', array(
				'KEY'			=> $config_key,
				'TITLE'			=> (isset($user->lang[$vars['lang']])) ? $user->lang[$vars['lang']] : $vars['lang'],
				'S_EXPLAIN'		=> $vars['explain'],
				'TITLE_EXPLAIN'	=> $l_explain,
				'CONTENT'		=> build_cfg_template($type, $config_key, $this->new_config, $config_key, $vars), 
				)
			);
			unset($display_vars['vars'][$config_key]);			
		}
	}
}	
				
?>