<?php

/**
*
* @package - Affiliates on index
* @version $Id: functions_affiliates_index.php 23 2010-27-09 06:41:09Z jakk $
* @copyright (c) jakk ( www.ivemfinity.com/ )
* @based on: Board3 portal by (c) kevin / saint ( www.board3.de/ ), (c) Ice, (c) nickvergessen ( www.flying-bits.org/ ), (c) redbull254 ( www.digitalfotografie-foren.de ), (c) Christian_N ( www.phpbb-projekt.de )
* @license http://opensource.org/licenses/gpl-license.php GNU Public License 
*
*/

if (!defined('IN_PHPBB'))
{
   exit;
}

// Get affiliates_index config
function obtain_affiliates_index_config()
{
	global $db, $cache;

	if (($affiliates_index_config = $cache->get('affiliates_index_config')) !== true)
	{
		$affiliates_index_config = $cached_affiliates_index_config = array();

		$sql = 'SELECT config_name, config_value
			FROM ' . AFFILIATES_INDEX_CONFIG_TABLE;
		$result = $db->sql_query($sql);

		while ($row = $db->sql_fetchrow($result))
		{
			$cached_affiliates_index_config[$row['config_name']] = $row['config_value'];
			$affiliates_index_config[$row['config_name']] = $row['config_value'];
		}
		$db->sql_freeresult($result);

		$cache->put('affiliates_index_config', $cached_affiliates_index_config);
	}

	return $affiliates_index_config;
}

/**
* Set config value. Creates missing config entry.
*/
function set_affiliates_index_config($config_name, $config_value)
{
	global $db, $cache, $affiliates_index_config;

	$sql = 'UPDATE ' . AFFILIATES_INDEX_CONFIG_TABLE . "
		SET config_value = '" . $db->sql_escape($config_value) . "'
		WHERE config_name = '" . $db->sql_escape($config_name) . "'";
	$db->sql_query($sql);

	if (!$db->sql_affectedrows() && !isset($affiliates_index_config[$config_name]))
	{
		$sql = 'INSERT INTO ' . AFFILIATES_INDEX_CONFIG_TABLE . ' ' . $db->sql_build_array('INSERT', array(
			'config_name'	=> $config_name,
			'config_value'	=> $config_value));
		$db->sql_query($sql);
	}

	$affiliates_index_config[$config_name] = $config_value;
}

?>